;
; BATTLETOADS & DD MSU-1 PATCH
; rev 1.8
;
; CODER: Conn, Kurrono, PepilloPEV [additional add-ons]
; DATE: 2018.08.08

; v1.1 add additional msu music support - select player and boss themes [conn, pev]
; v1.2 add additional msu music support - crazy ride theme [pev]
; v1.3 crazy ride theme support added, mapped to track 10
; v1.4 fixed missing boss themes (roper, roboMagnus, shadow boss, and dark queen) - plays same boss theme 1 only
; v1.5 add additional msu music support - stage clear theme [pev]
; v1.6 stage clear bug fixes and implemented experimental support for boss theme 2 [pev]
; v1.7 sega genesis edition stable edition, i hope ;) [pev]
; v1.8 fixed issue where Rat Boss theme would not play. [pev]
; v1.9 fixed l5 boss, stage 14 to play one time ($2007-01) 

lorom

; note
; rat ship boss time
; 81db90 lda #$ffff             A:0000 X:0014 Y:000e S:01f8 D:0000 DB:81 nvmxdIZC V:261 H:178 F:36 3b
; 81db93 sta $0866,x   [81087a] A:ffff X:0014 Y:000e S:01f8 D:0000 DB:81 NvmxdIzC V:261 H:182 F:36 3b          A:014b X:0014 Y:0021 S:01f8 D:0000 DB:81 nvmxdIzc V:257 H: 30 F:36 3b
;
; rat ship explode
; 81d161 adc #$0050             A:0009 X:0004 Y:0016 S:01f8 D:0000 DB:81 nvmxdIzc V:254 H:232 F:10 3b
; 81d164 sta $0a26,y   [810a3c] A:0059 X:0004 Y:0016 S:01f8 D:0000 DB:81 nvmxdIzc V:254 H:237 F:10 3b
;
; stage 5 mini boss
; 00885b stz $c2       [0000c2] A:ffff X:003e Y:0000 S:01fe D:0000 DB:80 NvmxdIzc V:142 H:218 F:35 2b
; 00885d stz $be       [0000be] A:ffff X:003e Y:0000 S:01fe D:0000 DB:80 NvmxdIzc V:142 H:226 F:35 2b
;
; restore stage 5 music after mini boss
; 008616 lda $4212     [804212] A:0000 X:0002 Y:0030 S:01fe D:0000 DB:80 nvMxdIZC V: 34 H:155 F: 4 3b
; 008619 and #$80               A:0002 X:0002 Y:0030 S:01fe D:0000 DB:80 nvMxdIzC V: 34 H:162 F: 4 2b
;
; possible stage clear, perfectly mimicks the Genesis version, but does not work on Dark Queen last boss
; 008194 jsl $8affb4   [8affb4] A:0202 X:0002 Y:0030 S:01fc D:0000 DB:80 nvmxdIzC V:237 H:166 F:45 4b
; 8affb4 wai                    A:0202 X:0002 Y:0030 S:01f9 D:0000 DB:80 nvmxdIzC V:237 H:181 F:45 1b
; 8affb5 dec $be       [0000be] A:0202 X:0002 Y:0030 S:01f9 D:0000 DB:80 nvmxdIzC V:233 H:166 F:46 2b
; 8affb7 bne $ffb4     [8affb4] A:0202 X:0002 Y:0030 S:01f9 D:0000 DB:80 nvmxdIzC V:233 H:179 F:46 2b
;
; 82c906 lda $7e       [00007e] A:0000 X:0230 Y:000a S:01ec D:0000 DB:82 nvmxdIzc V: 44 H: 73 F: 9 2b
; 82c908 sta $0a,x     [00023a] A:3c68 X:0230 Y:000a S:01ec D:0000 DB:82 nvmxdIzc V: 44 H: 80 F: 9 2b
;

; hooks
org $94a2d0 ; hard mute
db $00,$00,$00,$00,$00,$00,$00

;org $008194 ; stage clear [perfectly mimicks the Genesis version, but does not work on Dark Queen last boss]
;JSL stageClear

org $9580C9
JSL msuTrack

org $00885B ; stage 5 mini boss
JSL s5mBoss

org $008616 ; restore stage 5 music after mini boss
JSL restoreStage5
NOP

org $82C906
JSL ratShipBoss

org $81B124 ; air bike stage
JSL crazyRide
NOP
NOP

org $80F78B ; Conn
JSL bossTrack
NOP
NOP

org $97DF42 ; select player
JSL selectPlayer


; patch code area
org $10AEB0
; stage clear support for all? except mini-bosses in stage 5 [don't use theme]
stageClear:
PHA
PHP
SEP #$20 ; set 8bit A
LDA #$14 ; load stage clear theme value
JSL msuRoutine
PLP
PLA
JSL msuDelay ; delay the game until msu stage theme clear music is done playing
PHA
PHX
PHY
JSL $8AFFB4 ; native code [jumps to WAI, hardware interrupt, starts screen fade?]
PLY
PLX
PLA
RTL

; delay until stage clear theme is done playing
msuDelay:
PHA
LDA #$0001
STA $7E1FD8
reDo:
LDA #$FFFF
STA $7E1FDB
mdBack:
DEC A
STA $7E1FDB
CMP #$0000 ; is wait for stage clear playing first counter done?
BNE mdBack
LDA $7E1FD8
INC $1FD8
CMP #$000A ; perfect 2nd delay for stage clear to play, locks up after Dark Queen
BNE reDo
PLA
RTL

; stage 5 mini boss (general slaugther?)
s5mBoss:
CMP #$FFFF
BNE noMini
PHP
SEP #$20 ; set 8-bit A
PHA
LDA $0032 ; load current level status
CMP #$04 ; are we in stage 5?
BEQ playBoss2m
mbBack:
PLA
PLP
noMini:
STZ $C2 ; native code
STZ $BE ; native code
RTL

; restore stage 5 music after mini boss
restoreStage5:
LDA $4212 ; native code
AND #$80 ; native code

PHA
LDA $7E1FDB ; all 3 mini bosses dead?
CMP #$03
BEQ ignoreRestore
LDA $7E1FDC ; did we finish all mini bosses?
CMP #$04
BCS doNothing ; if less than 4
STA $7E1FDB ; store kill count
;------Conn stage 5 fix---------------------------------
LDA $7E1FDE
CMP #$11  ; is boss theme already playing?
BEQ $02
; end Conn stage 2 fix----------------------------------
LDA #$0F ; load stage 5 music
JSL msuRoutine
goBack:
ignoreRestore:
PLA
RTL
doNothing:
JMP goBack

; play boss theme2 for mini boss
playBoss2m:
LDA #$13 ; load boss theme 2
JSL msuRoutine
JMP mbBack

; Rat Ship Boss Battle
ratShipBoss:
LDA $7E ; native code
STA $0A,X ; native code
PHP
SEP #$20 ; set 8-bit A
PHA
LDA $0032 ; load current level status
CMP #$03 ; are we in stage 4-2? rat ship?
BEQ playBoss2b
rbBack:
PLA
PLP
RTL

; boss theme 2 for Rat Ship
playBoss2b:
LDA $0034 ; is this stage 4-2?
CMP #$01
BEQ yes42
JMP rbBack
yes42:
LDA #$13 ; load boss theme 2
JSL msuRoutine
JMP rbBack

; Rat Ship Stage Clear
ratShipClear:
PHP
SEP #$20 ; set 8-bit A
PHA
LDA $0032 ; load current level status
CMP #$03 ; are we in stage 4? rat ship?
BEQ Stage4
rsBack:
PLA
PLP
ADC #$0050 ; native code
STA $0A26,Y ; native code
RTL

; Rat Ship Cleared
Stage4:
LDA #$14 ; load stage clear theme
JSL msuRoutine
JMP rsBack

; Crazy Ride Routine START
crazyRide:
STA $0F52,Y ; native code
LDA #$006D ; native code
SEP #$20 ; need to change to 8-bit A register
CMP #$6D
BEQ playCrazyRide
REP #$20 ; restore 16bit A register
RTL

playCrazyRide:
PHA
LDA #$0A
JSL msuRoutine
PLA
REP #$20 ; restore 16bit A register
RTL
; Crazy Ride Routine END


; Boss Track Routine START
bossTrack:
STA $09E6,x ;native code
PHA
SEP #$20 ; need to change to 8-bit A register

LDA $01ED
CMP #$C8 ; abobo? stage 1?
BEQ playBoss
CMP #$1D ; big blag? stage 2?
BEQ playBoss2a
CMP #$BA ; shadow boss and dark queen? stage 6 or 7?
BEQ playBoss2a

LDA $00C3 ; roper? stage 3?
CMP #$2A
BEQ playBoss
CMP #$10 ; robo magnus? stage 5?
BEQ playBoss

bBack:
LDA $07CA,x ; native code
REP #$20 ; restore 16bit A register
PLA
RTL
playBoss:
LDA #$11 ; map boss theme 1 to 17 decimal
JSL msuRoutine ; routine restores with PLP
JMP bBack
playBoss2a:
LDA #$13 ; map boss theme 2
JSL msuRoutine ; routine restores with PLP
JMP bBack
; Boss Track Routine END


; Select Player Routine START
selectPlayer:
LDA $0000,X
INX
PHA
LDA $0540
CMP #$FF ; is player select flag set, as to not repeat msu code?
BEQ ctLeave
LDA $0024
CMP #$C4 ; are we at player select screen?
BEQ playerTune
ctLeave:
PLA
RTL

playerTune:
LDA #$10 ; map player select theme to 17 decimal
JSL msuRoutine
LDA #$FF ; set player select theme already playing flag, to avoid msu multiple playback issues
STA $0540
PLA
RTL
; Select Player Routine END


msuTrack:
PHA
PHP ;save processor status
SEP #$20
lda $2002
CMP #$53
BEQ $07
PLP ;restore processor status
PLA ;native code if no msu
LDA $958088,x
RTL
PLP ;restore processor status
PLA ;get track number from stack
PHA
PHP ;save processor status again
SEP #$20
JSL msuRoutine
PLP ;restore processor status
PLA
LDA $958088,x
RTL

; msu1 playback routine
msuRoutine:
CMP #$00 ; is this game intro? bypass double protection (since intro hook repeats twice)
BEQ yesIntro
CMP $7E1FDE ; is stage clear already playing?
BEQ mLeave
yesIntro:
STZ $2006
STA $2004
STA $7E1FDE ; store track in RAM, debug
STZ $2005
loop:
bit $2000
BVS loop
;-------Conn: disable 14 double play
CMP #$14
BNE $04
LDA #$01
BRA $02
LDA #$03
STA $7E1FDF ; store loop in RAM, debug
STA $2007
LDA #$ff
STA $2006
mLeave:
RTL